From d36561c8cc91698f3075c264af6d7d99e13cbff0 Mon Sep 17 00:00:00 2001
From: rakshasa <sundell.software@gmail.com>
Date: Sun, 25 Dec 2016 12:09:35 +0900
Subject: [PATCH] More stuff.

---
 Makefile.am    |  1 +
 scripts/ssl.m4 | 39 +++++++++++++++++++++++++++++++++++++++
 2 files changed, 40 insertions(+)
 create mode 100644 scripts/ssl.m4

diff --git a/Makefile.am b/Makefile.am
index f175e634..9507b9ea 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -8,6 +8,7 @@ EXTRA_DIST= \
 	scripts/checks.m4 \
 	scripts/common.m4 \
 	scripts/attributes.m4 \
+	scripts/ssl.m4 \
 	doc/main.xml \
 	doc/http.xml \
 	doc/torrent.xml \
diff --git a/scripts/ssl.m4 b/scripts/ssl.m4
new file mode 100644
index 00000000..e9cf6303
--- /dev/null
+++ b/scripts/ssl.m4
@@ -0,0 +1,39 @@
+AC_DEFUN([TORRENT_CHECK_OPENSSL],
+  [
+    PKG_CHECK_MODULES(OPENSSL, libcrypto,
+      CXXFLAGS="$CXXFLAGS $OPENSSL_CFLAGS";
+      LIBS="$LIBS $OPENSSL_LIBS")
+
+    AC_DEFINE(USE_OPENSSL, 1, Using OpenSSL.)
+    AC_DEFINE(USE_OPENSSL_SHA, 1, Using OpenSSL's SHA1 implementation.)
+    AC_CHECK_LIB([crypto], [DH_set0_pqg], [AC_DEFINE(USE_OPENSSL_1_1, 1, Using OpenSSL 1.1.)])
+  ]
+)
+
+AC_DEFUN([TORRENT_ARG_OPENSSL],
+  [
+    AC_ARG_ENABLE(openssl,
+      [  --disable-openssl       Don't use OpenSSL's SHA1 implementation.],
+      [
+        if test "$enableval" = "yes"; then
+          TORRENT_CHECK_OPENSSL
+        else
+          AC_DEFINE(USE_NSS_SHA, 1, Using Mozilla's SHA1 implementation.)
+        fi
+      ],[
+        TORRENT_CHECK_OPENSSL
+      ])
+  ]
+)
+
+AC_DEFUN([TORRENT_ARG_CYRUS_RC4],
+  [
+    AC_ARG_ENABLE(cyrus-rc4,
+      [  --enable-cyrus-rc4=PFX  Use Cyrus RC4 implementation.],
+      [
+        CXXFLAGS="$CXXFLAGS -I${enableval}/include";
+        LIBS="$LIBS -lrc4 -L${enableval}/lib"
+        AC_DEFINE(USE_CYRUS_RC4, 1, Using Cyrus RC4 implementation.)
+      ])
+  ]
+)
